\ PowerPC simplified mnemonics.
\
\ Copyright (C) 2006, 2007  Joshua I. Grams
\ May be used, modified, and redistributed without limitation.

:asm nop, 0 0 0 ;extends ori,
:asm li, 0 swap ;extends addi,
:asm lis, 0 swap ;extends addis,
:asm mr, dup ;extends or,
:asm not, dup ;extends nor,
:asm mtcr, 255 ;extends mtcrf,

:asm subi, negate ;extends addi,
:asm subis, negate ;extends addis,
:asm subic, negate ;extends addic,
:asm sub, swap ;extends subf,
:asm subc, swap ;extends subfc,

:asm cmpwi, 0 -rot ;extends cmpi,
:asm cmpw, 0 -rot ;extends cmp,
:asm cmplwi, 0 -rot ;extends cmpli,
:asm cmplw, 0 -rot ;extends cmpl,

:asm extlwi, swap 0 swap 1- ;extends rlwinm,
:asm extrwi, over +  32 rot -  31 ;extends rlwinm,
:asm inslwi, 2dup + >r  32 over - swap  r> ;extends rlwinm,
:asm insrwi, tuck + >r  32 r@ - swap  r> 1- ;extends rlwinm,
:asm rotlwi, 0 31 ;extends rlwinm,
:asm rotrwi, 32 swap - 0 31 ;extends rlwinm,
:asm rotlw, 0 31 ;extends rlwnm,
:asm slwi, 0 over 31 swap - ;extends rlwinm,
:asm srwi, 32 over - swap 31 ;extends rlwinm,
:asm clrlwi, 0 swap 31 ;extends rlwinm,
:asm clrrwi, >r 0 0 31 r> - ;extends rlwinm,
:asm clrlswi, swap over - over 31 swap - ;extends rlwinm,

:asm b*, 20 swap 0 swap ;extends bc,
:asm bt, 12 -rot ;extends bc,
:asm bf, 4 -rot ;extends bc,
:asm bdnz, 16 -rot ;extends bc,
:asm bdnzt, 8 -rot ;extends bc,
:asm bdnzf, 0 -rot ;extends bc,
:asm bdz, 18 -rot ;extends bc,
:asm bdzt, 10 -rot ;extends bc,
:asm bdzf, 2 -rot ;extends bc,

:asm blr, 20 0 ;extends bclr,
:asm btlr, 12 swap ;extends bclr,
:asm bflr, 4 swap ;extends bclr,
:asm bdnzlr, 16 swap ;extends bclr,
:asm bdnztlr, 8 swap ;extends bclr,
:asm bdnzflr, 0 swap ;extends bclr,
:asm bdzlr, 18 swap ;extends bclr,
:asm bdztlr, 10 swap ;extends bclr,
:asm bdzflr, 2 swap ;extends bclr,

:asm bctr, 20 0 ;extends bcctr,
:asm btctr, 12 swap ;extends bcctr,
:asm bfctr, 4 swap ;extends bcctr,

:asm blt, LT ;extends bt,
:asm bge, LT ;extends bf,
:asm ble, GT ;extends bf,
:asm bgt, GT ;extends bt,
:asm beq, EQ ;extends bt,
:asm bne, EQ ;extends bf,
:asm bns, SO ;extends bf,
:asm bso, SO ;extends bt,

:asm bltlr, LT ;extends btlr,
:asm bgelr, LT ;extends bflr,
:asm blelr, GT ;extends bflr,
:asm bgtlr, GT ;extends btlr,
:asm beqlr, EQ ;extends btlr,
:asm bnelr, EQ ;extends bflr,
:asm bnslr, SO ;extends bflr,
:asm bsolr, SO ;extends btlr,

:asm bltctr, LT ;extends btctr,
:asm bgectr, LT ;extends bfctr,
:asm blectr, GT ;extends bfctr,
:asm bgtctr, GT ;extends btctr,
:asm beqctr, EQ ;extends btctr,
:asm bnectr, EQ ;extends bfctr,
:asm bnsctr, SO ;extends bfctr,
:asm bsoctr, SO ;extends btctr,

:asm crset, dup dup ;extends creqv,
:asm crclr, dup dup ;extends crxor,
:asm crmove, dup ;extends cror,
:asm crnot, dup ;extends crnor,

:asm trap, T* -rot ;extends tw,
:asm twlt, T< -rot ;extends tw,
:asm twle, T< T= or -rot ;extends tw,
:asm tweq, T= or -rot ;extends tw,
:asm twge, T> T= or -rot ;extends tw,
:asm twgt, T> -rot ;extends tw,
:asm twnl, T> T= or -rot ;extends tw,
:asm twne, T< T> or -rot ;extends tw,
:asm twng, T< T= or -rot ;extends tw,
:asm twllt, T< -rot ;extends tw,
:asm twlle, T< T= or -rot ;extends tw,
:asm twlge, T> T= or -rot ;extends tw,
:asm twlgt, T> -rot ;extends tw,
:asm twlnl, T> T= or -rot ;extends tw,
:asm twlng, T< T= or -rot ;extends tw,

:asm twlti, T< -rot ;extends twi,
:asm twlei, T< T= or -rot ;extends twi,
:asm tweqi, T= or -rot ;extends twi,
:asm twgei, T> T= or -rot ;extends twi,
:asm twgti, T> -rot ;extends twi,
:asm twnli, T> T= or -rot ;extends twi,
:asm twnei, T< T> or -rot ;extends twi,
:asm twngi, T< T= or -rot ;extends twi,
:asm twllti, T< -rot ;extends twi,
:asm twllei, T< T= or -rot ;extends twi,
:asm twlgei, T> T= or -rot ;extends twi,
:asm twlgti, T> -rot ;extends twi,
:asm twlnli, T> T= or -rot ;extends twi,
:asm twlngi, T< T= or -rot ;extends twi,

:asm mtxer, 1 swap ;extends mtspr,
:asm mtlr, 8 swap ;extends mtspr,
:asm mtctr, 9 swap ;extends mtspr,
:asm mtdsisr, 18 swap ;extends mtspr,
:asm mtdar, 19 swap ;extends mtspr,
:asm mtdec, 22 swap ;extends mtspr,
:asm mtsdr1, 25 swap ;extends mtspr,
:asm mtsrr0, 26 swap ;extends mtspr,
:asm mtsrr1, 27 swap ;extends mtspr,
:asm mtsprg, swap 272 + swap ;extends mtspr,
:asm mtasr, 280 swap ;extends mtspr,
:asm mtear, 282 swap ;extends mtspr,
:asm mttbl, 284 swap ;extends mtspr,
:asm mttbu, 285 swap ;extends mtspr,
:asm mtibatu, swap 2* 528 + swap ;extends mtspr,
:asm mtibatl, swap 2* 529 + swap ;extends mtspr,
:asm mtdbatu, swap 2* 536 + swap ;extends mtspr,
:asm mtdbatl, swap 2* 537 + swap ;extends mtspr,

:asm mfxer, 1 ;extends mfspr,
:asm mflr, 8 ;extends mfspr,
:asm mfctr, 9 ;extends mfspr,
:asm mfdsisr, 18 ;extends mfspr,
:asm mfdar, 19 ;extends mfspr,
:asm mfdec, 22 ;extends mfspr,
:asm mfsdr1, 25 ;extends mfspr,
:asm mfsrr0, 26 ;extends mfspr,
:asm mfsrr1, 27 ;extends mfspr,
:asm mfsprg, 272 + ;extends mfspr,
:asm mfasr, 280 ;extends mfspr,
:asm mfear, 282 ;extends mfspr,
:asm mftbl, 284 ;extends mfspr,
:asm mftbu, 285 ;extends mfspr,
:asm mfpvr, 287 ;extends mfspr,
:asm mfibatu, 2* 528 + ;extends mfspr,
:asm mfibatl, 2* 529 + ;extends mfspr,
:asm mfdbatu, 2* 536 + ;extends mfspr,
:asm mfdbatl, 2* 537 + ;extends mfspr,
